<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Tutorial: Static combustion engine model</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Tutorial: Static combustion engine model</h1>

    <section>

<header>
    

    <h2>Static combustion engine model</h2>
</header>

<article>
    <!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta http-equiv="X-UA-Compatible" content="ie=edge" />
    <title>Signal Sources and Oscilloscope</title>
  </head>
  <style>
    .jsscript
    {
      font-weight: bold;  
      color:blue;  
    }

#objOfConst{
  width: 800px;
  height: auto;
  position: relative;
  top: 10px;
  left: 0px;
}

.objOfCharger{
  width: 800px;
  height: auto;
  position: relative;
  top: 10px;
  left: 0px;
}
.obj2dmap{
  width: 800px;
  height: auto;
  position: relative;
  top: 10px;
  left: 0px;
}

#confExplain{
  width: 1000px;
  height: auto;
  position: relative;
  top: 20px;
  left: 0px; 
}

footer{
  position: relative;
  top:20px; 
}

  </style>
  
  <body>       
    <h3>File Structure and Artifacts</h3>     
    <h4>File Structure</h4>     
    <p>
    <dl>
    <dt><ul><li class='jsscript'>main: root folder</li></ul></dt>
    <dd>
    <ul>
      <li>buildscripts : linux shell scripts to prepare build steps</li>
      <li>confGitlabRunner : runner configuration template for gitlab CI runner</li>
      <li>confPython : configuration info for python</li>
      <li>CSS : style sheets</li>
      <li>custom-template : customization configuration for the node documenation build</li>
      <li>docs : created documentations</li>
      <li class='jsscript'>HTML : web pages in HTML </li>
      <li>images : pictures for all kind of illustrations</li>
      <li>node_modules : created by npm install according to the package.json configuration</li>
      <li>node_scripts : customized javascript modules used by node.js</li>
      <li>projects : sub file structure that covers all projects underneath the main node.js application </li>
      <li class='jsscript'>Script : javascripts which are loaded into the client side HTML pages </li>
      <li>test : API self tests in Mocha using the Chai assertion library </li>
    </ul>
    </dd>
    </dl>

    The three highlighted folders are covering the functionality which shall be discussed by tutorial.  
    </p>
    <h4>Artifacts</h4>     
    <dl>
      <dt><ul><li>main: root folder</li></ul></dt>
      <dd>
      <ul>
        <li>index.js : main node.js application</li>
      </ul>
      </dd>
    </dl>
    <dl>
      <dt><ul><li>HTML: javascripts for client</li></ul></dt>
      <dd>
      <ul>
        <li>signalsNOsci.html : select input signals, distribute them to the simulation module and visualize all data</li>
      </ul>
      </dd>
    </dl>
    <dl>
      <dt><ul><li>Script: javascripts for client</li></ul></dt>
      <dd>
      <ul>
        <li>audio-element.js : audi file processing</li>
      </ul>
      </dd>
    </dl>


    </p> 
    <h3>Converting Amplitude-Time Behavior into Sound Files </h3>      
    <h4>csv_to_wav.y<h4>   
    <h2 id="algebEngModData">Data structure array for algebraic engine model</h2>
<p></p>
<hr>
<h3>Module : Script/createDataViz.js </h3>
<table>
<caption>configData'div'</caption>
<thead>
<tr>
  <th>class name 'div'</th>
  <th>header name 'h3'</th>
  <th>elements 'button'</th>
</tr>
</thead>
<tbody>
<tr>
  <td>engine</td>
  <td>Engine Data</td>
  <td>'EngineConstants','EngineAmbientConditions','EngineEta','EngineFriction','EngineVolumEff'</td>
</tr>
<tr>
  <td>compressor</td>
  <td>CompressorData</td>
  <td>'EngineCompr','EngineFullLoadData'</td>
</tr>
<tr>
  <td>turbine</td>
  <td>VNT Data</td>
  <td>'EngineTurbine'</td>
</tr>
<tr>
  <td>exhaust</td>
  <td>Exhaust Data</td>
  <td>'EngineExhaustParam'</td>
</tr>
<tr>
  <td>emissions</td>
  <td>Emmission Data</td>
  <td>'EngineRawParticulates','EngineRawNox'</td>
</tr>
<tr>
  <td>roadloads</td>
  <td>Road loads</td>
  <td>'EngineRoadLoads'</td>
</tr>
</tbody>
</table>
<p>Table 1</p>
<p>The algebraic engine model is divided into 6 topics which are visulized by 6 buttons. Each topic is structured by the following elements: 
  <li>h3 headline : top element of each topic</li>
  <li>button : the user my activate each topic by pressing a pushbutton </li>
  <li>callback function on pushed button : a topic specific table editor creator function </li>
  There are 12 keys for 12 datasets in the posgres data set. The 12 keys are connected to the 6 topics according to table 1. 
</p>
<hr>
<h3>Module handleModelData.js</h3>
<p></p>

<table>
<caption>configArray</caption>
<thead>
<tr>
<th>name</th>
<th>data</th>
</tr>
</thead>
<tbody>
<tr>
<td>EngineConstants</td>
<td>['Tamb[K]','Pamb[bar]','R [J/kg/K]','Lambda_ref','E_LHV [J/kg]','C_p[J/kg/K]','Gamma(C_p/C_v)','Fuel H/C Ratio']</td>
</tr>
<tr>
<td>EngineFullLoadData</td>
<td>['Engine type, 2-stoke:1, 4-Stroke:2','Engine Cylinders','Engine Displacement [m^3]']</td>
</tr>
<tr>
<td>EngineAmbientConditions</td>
<td>['DfuelSp[kg/m^3]/S_p[m/s]']</td>
</tr>
<tr>
  <td>EngineEta</td>
  <td>['FExh/Fman']</td>
</tr>
<tr>
  <td>EngineFriction</td>
  <td>['Dman [kg/m^3] / S_p [m/s][kPa]']</td>
</tr>
<tr>
  <td>EngineVolumEff</td>
  <td>['Dman [kg/m^3] / S_p [m/s]']</td>
</tr>
<tr>
  <td>EngineCompr</td>
  <td>['Ncor[rpm]', 'WcompCor[kg/s]','PrComp[-]','EtaComp[-]','P_ref [Pa]','T_ref [K]','TCompDoCrit [K]']</td>
</tr>
<tr>
  <td>EngineFullLoadData</td>
  <td>['Engine type, 2-stoke:1, 4-Stroke:2','Engine Cylinders','Engine Displacement [m^3]']</td>
</tr>
<tr>
  <td>EngineTurbine</td>
  <td>['ThVNT','Ncor','PrTurb','WTurbCor','EtaTurb']</td>
</tr>
<tr>
  <td>EngineExhaustParam</td>
  <td>['Assumed Average Turbine Efficiency','Average Exhaust Specific Heat,Cp[J/kg/K]','Average Exhaust Specific Heat Ratio[-]</td>
</tr>
<tr>
  <td>EngineExhaustParam</td>
  <td>['Assumed Average Turbine Efficiency','Average Exhaust Specific Heat,Cp[J/kg/K]','Average Exhaust Specific Heat Ratio[-],'Average Gas Constant, R[J/kg/K','Average Exhaust Gas Visc.[Pa*s]','Piece','Pipe Length[mm]','Outer Pipe Diameter[mm]',
    'pieces','Element length[mm]','Element Diameter[mm]','Element Cell Density[1/m^2]','AT element cell wall thickness[mm]','Fraction of cells blocked','Relative Roughness'] </td>
</tr>
</tr>
<tr>
  <td>EngineRawParticulates</td>
  <td>['DFuelSp [kg/m^3] / S_p [m/s]']</td>
</tr>
<tr>
  <td>EngineRawNox</td>
  <td>['DFuelSp [kg/m^3] / S_p [m/s]']</td>
</tr>
<tr>
  <td>EngineRoadLoads</td>
  <td>['Time[s]','Engine Speed[rpm]','BMEP[bar]']</td>
</tr>
</tbody>
</table>
<p>Table 2</p>
<p>
  Event handler for the pushbutton : creates topic specific table editors selected
  by the user on selecting a button <br>
  The handler executes the following steps:
  <li>delete previous editor tables : (d3.select('.table').selectAll('tr').remove();)</li> 
  <li>extract topic related data from postgres dataset (filter:key connected to the pushbutton) </li>
  <li>convert extracted data into a JS object var Obj = JSON.parse(postgresData[cmpString]</li>  
  <li>create a topic specific table editor</li>
 <br>
  The key values of the postgres data are listed in the name element of a JS object. The data field of the object contains those keys which 
  are expected in the columns of the postgres data structure of the corresponding topic (see table 2).  
</p>
<p>
  The table editors are created by the following functions : 
  <li>function insertHeadline(headline) : select the empty table capsule by ID and set table caption to key value (eq. to button name)</li>
  <li>function insertRow (collector,data) : insert a new row (tr elmenent)</li>
  <li>insertCell()</li>
  The following screeshots show examples for the 3 implemented data structures and their configuration. 
</p>
<h4>Configuration</h4>
<li>The name member consists of the 12 keys for in the postgres dataset</li>
<li>The data member consists of all expected columns names for one topic in the postgres dataset</li>

  <div id="objOfConst">     
    <h4>Set of constants</h4>
    <img src="DispatchJSConststObj.png" />    
    <p>The data tag in configArray contains the expected column names. In a loop over all expected column names and the column names the 
      order of the data columns is found and pushed into a collector array.The collector vector with the names is the 1st row of an 
    outer collector vector. In case of data constants the 2nd row contains the data vector of the postgres structure.</p> 
  </div>
  <div class="objOfCharger">     
    <h4>Set of characteristic turbo charger curves</h4>
    <img src="disPatchChargerObj.png" />
    <p>The data tag in configArray contains the expected column names. In a loop over all expected column names and the column names the 
      order of the data columns is found and pushed into a collector array.The collector vector with the names is the 1st row of an 
    outer collector vector. In case of data constants the 2nd row contains the data vector of the postgres structure.</p> 
  </div>
  <div class="objOfCharger">     
    <h4>Collecting the configured columns</h4>
    <img src="CollectorCurves.png" />
    <p>The data tag in configArray contains the expected column names. In a loop over all expected column names and the column names the 
      order of the data columns is found and pushed into a collector array.The collector vector with the names is the 1st row of an 
    outer collector vector. In case of data constants the 2nd row contains the data vector of the postgres structure.</p> 
  </div>
  <div class="objOfCharger">     
    <h4>Collecting dta in one array</h4>
    <img src="CmprObj.png" />
    <p>The data tag in configArray contains the expected column names. In a loop over all expected column names and the column names the 
      order of the data columns is found and pushed into a collector array.The collector vector with the names is the 1st row of an 
    outer collector vector. In case of data constants the 2nd row contains the data vector of the postgres structure.</p> 
  </div>
  <div class="objOfCharger"> 
    <h4>Filter specific curves in compressor and turbine characteristic data</h4>             
    <img src="CurveSplitData.png" />    
    <p>Similar to a set of constants the set of curves is found. In case of a set of curves there is not only one data vector but a set of
      data vectors which is pushed into the outer vector. 
      <br>
      This type of curve sets are used to characterize the turbine and the compressor of the turbo charger. The comprObj shows the example 
      for the compressor. Instead of using the complete set of data vectors as this is the case for 2d maps the collector array with the 
      names is compared to a vector with a selection of needed columns (see columns element in comprObj). One of these columns is defined 
      as the trigger condition to create new data. 
      <br>
      The headAr structure array shows the example for the turbo charger and the compressor. Element 1 contains compressor data. The compressor
      speed Ncor[rpm] is defined as the trigger condition. According to the trigger the dataset is evaluated for data with equal compressor Speed
      values. Those data triplets with equal compressor speed are pushed to the databuf field. The example shows the values for WcomCor, Prcomp and
      EtaComp for one compressor speed. Each speed gets a new entry into databuf. Each entry consists of the 3 values for the 3 physical entities. 

       <h5>var TurbineObj = {};</h5>
      <li>TurbineObj.name = 'EngineTurbine';</li>
      <li>TurbineObj.trig = 'ThVNT';</li>
      <li>TurbineObj.trigNo = 0;</li>
      <li>TurbineObj.colNames = ['PrTurb','WTurbCor','EtaTurb'];</li>
      <li>TurbineObj.colNmbrs = [0,0,0];</li>
      <li>TurbineObj.databuf = [];</li>
     
      <h5>var comprObj = {};</h5>
      <li>comprObj.name = 'EngineCompr';</li>
      <li>comprObj.trig = 'Ncor[rpm]';</li>
      <li>comprObj.trigNo = 0;</li>
      <li>comprObj.colNames = ['WcompCor[kg/s]','PrComp[-]','EtaComp[-]'];</li>
      <li>comprObj.colNmbrs = [0,0,0];</li>
      <li>comprObj.databuf = [];</li>

    </p> 
  </div>
  <div class="obj2dmap">     
    <h4>2d map - first column is the index</h4>
    <img src="DispatchJSObject.png" />      
    <p>The data tag in configArray contains the expected column names. In a loop over all expected column names and the column names the 
      order of the data columns is found and pushed into a collector array.The collector vector with the names is the 1st row of an 
    outer collector vector. In case of data constants the 2nd row contains the data vector of the postgres structure.</p> 
  </div>
  <div class="obj2dmap"> 
    <h4>2d map </h4>       
    <img src="CollectorMap.png " />  
    <p>Property is characterized by a 2d map / 1st column contains the index. 
      function specialMap(cmpString)
  <br>{
    <br>&nbsp switch(cmpString)
    <br>&nbsp{
      <br>&nbsp&nbsp&nbsp&nbsp case 'EngineAmbientConditions' : return true; 
      <br>&nbsp&nbsp&nbsp&nbsp case 'EngineEta' : return true; 
      <br>&nbsp&nbsp&nbsp&nbsp case 'EngineFriction' : return true; 
      <br>&nbsp&nbsp&nbsp&nbsp case 'EngineVolumEff' : return true; 
      <br>&nbsp&nbsp&nbsp&nbsp case 'EngineRawParticulates' : return true; 
      <br>&nbsp&nbsp&nbsp&nbsp case 'EngineRawNox' : return true; 
      <br>&nbsp}
      <br>}
    </p>
  </div>  
  <div class="datSel">     
    <h4>2d map - first column is the index</h4>
    <img src="DataSelectorButtons.png" />      
    <p>The data tag in configArray contains the expected column names. In a loop over all expected column names and the column names the 
      order of the data columns is found and pushed into a collector array.The collector vector with the names is the 1st row of an 
    outer collector vector. In case of data constants the 2nd row contains the data vector of the postgres structure.</p> 
  </div>
  <div class="crvEdit">     
    <h4>2d map - first column is the index</h4>
    <img src="DataSelectorCurveEdit.png" />      
    <p>The data tag in configArray contains the expected column names. In a loop over all expected column names and the column names the 
      order of the data columns is found and pushed into a collector array.The collector vector with the names is the 1st row of an 
    outer collector vector. In case of data constants the 2nd row contains the data vector of the postgres structure.</p> 
  </div>
  <div class="mapEdit">     
    <h4>2d map - first column is the index</h4>
    <img src="DataSelectorMapEdit.png" />      
    <p>The data tag in configArray contains the expected column names. In a loop over all expected column names and the column names the 
      order of the data columns is found and pushed into a collector array.The collector vector with the names is the 1st row of an 
    outer collector vector. In case of data constants the 2nd row contains the data vector of the postgres structure.</p> 
  </div>
  <div class="cnstEdit">     
    <h4>2d map - first column is the index</h4>
    <img src="editConst.png" />      
    <p>The data tag in configArray contains the expected column names. In a loop over all expected column names and the column names the 
      order of the data columns is found and pushed into a collector array.The collector vector with the names is the 1st row of an 
    outer collector vector. In case of data constants the 2nd row contains the data vector of the postgres structure.</p> 
  </div>
  <div class="graphEdit">     
    <h4>2d map - first column is the index</h4>
    <img src="editGraphically.png" />      
    <p>The data tag in configArray contains the expected column names. In a loop over all expected column names and the column names the 
      order of the data columns is found and pushed into a collector array.The collector vector with the names is the 1st row of an 
    outer collector vector. In case of data constants the 2nd row contains the data vector of the postgres structure.</p> 
  </div>
  <div class="switchView">     
    <h4>2d map - first column is the index</h4>
    <img src="switchToViews.png" />      
    <p>The data tag in configArray contains the expected column names. In a loop over all expected column names and the column names the 
      order of the data columns is found and pushed into a collector array.The collector vector with the names is the 1st row of an 
    outer collector vector. In case of data constants the 2nd row contains the data vector of the postgres structure.</p> 
  </div>
</p>
<div id="confExplain">

  
  
  
  
  
  
  




    </div>
  </body>
</html>
</article>

</section>

</div>

<nav>
    <h2><a href="index.html">Connected Controls Web App Docu</a></h2><h3>Modules</h3><ul><li><a href="module-a_index_server.html">a_index_server</a></li><li><a href="module-b_create_caldata_buttons_client.html">b_create_caldata_buttons_client</a></li><li><a href="module-c_socketCom_server.html">c_socketCom_server</a></li><li><a href="module-d_handleModelData_client.html">d_handleModelData_client</a></li><li><a href="module-e_getModelStimulationData_server.html">e_getModelStimulationData_server</a></li><li><a href="module-f_getPostgresData_server.html">f_getPostgresData_server</a></li><li><a href="module-g_setPostgresData_server.html">g_setPostgresData_server</a></li><li><a href="module-h_deletePostgresData_server.html">h_deletePostgresData_server</a></li><li><a href="module-i_getPostgresWOsocket_server.html">i_getPostgresWOsocket_server</a></li><li><a href="module-j_updatePostgresData_server.html">j_updatePostgresData_server</a></li><li><a href="module-k_select-stimulation_client.html">k_select-stimulation_client</a></li><li><a href="module-l_3d_map_visualization_client.html">l_3d_map_visualization_client</a></li><li><a href="module-m_curveGraphGenerator_client.html">m_curveGraphGenerator_client</a></li><li><a href="module-n_create_simulation_view_client.html">n_create_simulation_view_client</a></li><li><a href="module-o_3d_map_visualization_initialization_client.html">o_3d_map_visualization_initialization_client</a></li><li><a href="module-p_3d_map_table_generator.html">p_3d_map_table_generator</a></li></ul><h3>Namespaces</h3><ul><li><a href="audio.k_1_startStimulation.html">k_1_startStimulation</a></li><li><a href="b_create_caldata_buttons_client.b_1_dataviz.html">b_1_dataviz</a></li><li><a href="b_create_caldata_buttons_client.b_1_dataviz.b_1_1_getClassNames.html">b_1_1_getClassNames</a></li><li><a href="b_create_caldata_buttons_client.b_1_dataviz.b_1_3_getAllButtonNames.html">b_1_3_getAllButtonNames</a></li><li><a href="b_create_caldata_buttons_client.b_1_dataviz.b_1_4_thermdata_client.html">b_1_4_thermdata_client</a></li><li><a href="c_socketCom_server.c_1_socketfunction.html">c_1_socketfunction</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html">c_1_1_socketConnected</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_1_initNewData.html">c_1_1_1_initNewData</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_2_tabledata.html">c_1_1_2_tabledata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_3_curvedata.html">c_1_1_3_curvedata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_4_getTable.html">c_1_1_4_getTable</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_5_getCurve.html">c_1_1_5_getCurve</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_6_getStimData.html">c_1_1_6_getStimData</a></li><li><a href="data.d_1_handler.html">d_1_handler</a></li><li><a href="m_curveGraphGenerator_client.m_1_curveGraphGenerator.html">m_1_curveGraphGenerator</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.html">n_1_create_simulation_view</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.n_1_1_rcvAudioFilePaths.html">n_1_1_rcvAudioFilePaths</a></li></ul><h3>Classes</h3><ul><li><a href="d3.html">d3</a></li><li><a href="express.html">express</a></li><li><a href="pool.html">pool</a></li><li><a href="response.html">response</a></li><li><a href="router.html">router</a></li><li><a href="selection.html">selection</a></li><li><a href="server.html">server</a></li><li><a href="socket.html">socket</a></li></ul><h3>Events</h3><ul><li><a href="b_create_caldata_buttons_client.b_1_dataviz.html#.event:thermdata">thermdata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:curvedata">curvedata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:disconnect">disconnect</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:getAudioFlPths">getAudioFlPths</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:getCurve">getCurve</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:getTable">getTable</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:initNewData">initNewData</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:tabledata">tabledata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:time">time</a></li><li><a href="c_socketCom_server.c_1_socketfunction.html#.event:connection">connection</a></li><li><a href="data.d_1_handler.html#.event:curvedata">curvedata</a></li><li><a href="data.d_1_handler.html#.event:initNewData">initNewData</a></li><li><a href="data.d_1_handler.html#.event:tabledata">tabledata</a></li><li><a href="module-e_getModelStimulationData_server.html#~event:sendAudioFlPths">sendAudioFlPths</a></li><li><a href="m_curveGraphGenerator_client.m_1_curveGraphGenerator.html#.event:getCurve">getCurve</a></li><li><a href="m_curveGraphGenerator_client.m_1_curveGraphGenerator.html#.event:sendCurve">sendCurve</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.html#.event:getAudioFlPths">getAudioFlPths</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.html#.event:periodic_time">periodic_time</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.html#.event:sendAudioFlPths">sendAudioFlPths</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.n_1_1_rcvAudioFilePaths.html#.event:click_stimFileSelector">click_stimFileSelector</a></li></ul><h3>Tutorials</h3><ul><li><a href="tutorial-codeAnalysisAndRefactoring.html">Static source code analysis and refactoring interface</a></li><li><a href="tutorial-conceptUnitTest.html">conceptUnitTest</a></li><li><a href="tutorial-graphicalEditor.html">Graphical editor for maps and curves</a></li><li><a href="tutorial-modelStimulation.html">Stimulation of physical and engine control models</a></li><li><a href="tutorial-staticEngineModel.html">Static combustion engine model</a></li><li><a href="tutorial-webclients.html">webclients</a></li></ul><h3>Global</h3><ul><li><a href="global.html#buildNav">buildNav</a></li><li><a href="global.html#publish">publish</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc/jsdoc">JSDoc 3.6.7</a> on Fri Sep 17 2021 09:09:23 GMT+0200 (Mitteleuropäische Sommerzeit)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>